# Generated by Django 2.1.3 on 2020-09-07 11:37

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone
import simple_history.models


class Migration(migrations.Migration):

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('customers', '0006_auto_20200813_1103'),
        # ('utp', '0014_auto_20200813_1103'),
        ('utp', '0014_historicalinterface_interface_neighbor'),
    ]

    function = "create or replace function get_status_display(status integer) returns text language plpgsql as $$ \
                declare out text; begin case \
                when status=1 then out := 'activo'; \
                when status=2 then out := 'por retirar'; \
                when status=3 then out := 'retirado'; \
                when status=4 then out := 'no instalado'; \
                when status=5 then out := 'canje'; \
                when status=6 then out := 'instalación rechazada'; \
                when status=7 then out := 'venta en verde'; \
                when status=8 then out := 'moroso'; \
                when status=9 then out := 'por re-agendar'; \
                when status=10 then out := 'cambio de titular'; \
                when status=11 then out := 'descartado'; \
                when status=12 then out := 'baja temporal'; \
                when status=13 then out := 'perdido, no se pudo retirar'; \
                end case; \
                return out;\
                end;\
                $$;"

    viewOne = "create or replace view change_status_node as \
            select row_number()over() as id,\
            m.alias as node,\
            get_status_display(ssl.status) as status,\
            count(ssl.status) as apariciones,\
            date(ssl.created_at) as fecha \
            from \
            utp_servicestatuslog ssl \
            inner join utp_mikrotik m on m.id = ssl.node_id \
            group by ssl.status,m.alias,fecha \
            order by fecha asc"

    viewTwo = 'create or replace view mikrotik_list as select id,alias from utp_mikrotik order by id asc'

    operations = [

        
        migrations.CreateModel(
            name='MikrotikList',
            fields=[
                ('id', models.IntegerField(primary_key=True, serialize=False)),
                ('alias', models.CharField(max_length=50)),
            ],
            options={
                'db_table': 'public"."mikrotik_list',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='HistoricalServiceStatusLog',
            fields=[
                ('id', models.IntegerField(auto_created=True, blank=True, db_index=True, verbose_name='ID')),
                ('created', models.DateTimeField(blank=True, editable=False)),
                ('modified', models.DateTimeField(blank=True, editable=False)),
                ('status_field', models.BooleanField(default=True)),
                ('id_data', models.UUIDField(blank=True, db_index=True, editable='True', null=True)),
                ('created_at', models.DateTimeField(default=django.utils.timezone.now)),
                ('status', models.PositiveSmallIntegerField()),
                ('seller', models.PositiveSmallIntegerField(blank=True, null=True)),
                ('technician', models.PositiveSmallIntegerField(blank=True, null=True)),
                ('history_id', models.AutoField(primary_key=True, serialize=False)),
                ('history_date', models.DateTimeField()),
                ('history_change_reason', models.CharField(max_length=100, null=True)),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('node', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='utp.Mikrotik', verbose_name='node')),
                ('service', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='customers.Service', verbose_name='service')),
            ],
            options={
                'verbose_name': 'historical service status log',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': 'history_date',
            },
            bases=(simple_history.models.HistoricalChanges, models.Model),
        ),
        migrations.CreateModel(
            name='ServiceStatusLog',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('modified', models.DateTimeField(auto_now=True)),
                ('status_field', models.BooleanField(default=True)),
                ('id_data', models.UUIDField(blank=True, db_index=True, editable='True', null=True)),
                ('created_at', models.DateTimeField(default=django.utils.timezone.now)),
                ('status', models.PositiveSmallIntegerField()),
                ('seller', models.PositiveSmallIntegerField(blank=True, null=True)),
                ('technician', models.PositiveSmallIntegerField(blank=True, null=True)),
                ('node', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='utp.Mikrotik', verbose_name='node')),
                ('service', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, to='customers.Service', verbose_name='service')),
            ],
            options={
                'abstract': False,
            },
        ),

        migrations.RunSQL(function),
        migrations.RunSQL(viewOne),
        migrations.RunSQL(viewTwo),
    ]


